#!/bin/bash
#compile les librairies 
. ../env.sh
if [ ! -d "$GSCRIPT_LIBSRC" ]; then mkdir -p $GSCRIPT_LIBSRC; fi;
if [ ! -d "$GSCRIPT_LIBDIR" ]; then mkdir -p $GSCRIPT_LIBDIR; fi;
if [ ! -d "$GSCRIPT_DIRAPP" ]; then mkdir -p $GSCRIPT_DIRAPP; fi


#f_read "question :" "valeur par defaut" "eval"; exporte $F_READ_RETURN
#f_read "ok?(y/N):" "n" "tr [:upper:] [:lower:]";GK=$F_READ_RETURN
function f_compilelib {
#set -x
	GSCRIPT_LIBNOM=$1
	GSCRIPT_LIBEXTRACONF=""
	GSCRIPT_LIBEXTRACMD=""
	if [ "$2"!="" ];then
		if [[ "$(echo $2|cut -c1-2)" == "--" ]];then
			GSCRIPT_LIBEXTRACONF=$2
		else
			GSCRIPT_LIBEXTRACMD=$2
		fi
	fi

	f_envcompil
	
	cd $GSCRIPT_LIBSRC
	if [ -z "$(ls -d $GSCRIPT_LIBNOM*/)" ];then
		f_untar $GSCRIPT_LIBNOM $GSCRIPT_LIBZIP $GSCRIPT_LIBSRC
		cd $GSCRIPT_LIBSRC
		GSCRIPT_LIBSRC_NOM_V=`ls -d $GSCRIPT_LIBNOM*/ |head -n1| sed -e 's:/::' 2>/dev/null`;
if [ "$GSCRIPT_LIBSRC_NOM_V" == "" ];then return; fi;
		#memo+export du nom avec version
		GSCRIPT_LIBSRC_NOM_S=`echo "$GSCRIPT_LIBNOM"| sed -e 's/-/_/g' 2>/dev/null`;
		export GSCRIPT_LIB_${GSCRIPT_LIBSRC_NOM_S}=$GSCRIPT_LIBSRC_NOM_V
#--prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIBSRC_NOM_V 
#--exec-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIBSRC_NOM_V

		echo "configure $GSCRIPT_LIBSRC_NOM_V"
		GSCRIPT_LIBCMDCONF="
		./configure \
			--cache-file=config.cache \
			$GSCRIPT_LIBEXTRACONF \
			--prefix=$GSCRIPT_LIBDIR \
			--exec-prefix=$GSCRIPT_LIBDIR
		"
		cd $GSCRIPT_LIBSRC_NOM_V
		if [ -f "configure" ]; then
			echo $GSCRIPT_LIBCMDCONF
			$GSCRIPT_LIBCMDCONF
#read
			echo "make $GSCRIPT_LIBNOM"
			make
#read
			echo "install $GSCRIPT_LIBNOM"
			make install
		fi
		if [ "$GSCRIPT_LIBEXTRACMD"!="" ]; then
			echo "compil spec $GSCRIPT_LIBNOM"
			echo $GSCRIPT_LIBEXTRACMD
#read
			eval $GSCRIPT_LIBEXTRACMD
		fi
	fi
	cd $GSCRIPT_LIBSRC
}

#libs de base pour les autres libs

#http://www.gzip.org/zlib/zlib-1.2.3.tar.gz
f_compilelib "zlib" "./configure --prefix=$GSCRIPT_LIBDIR --shared;\
	sed -e 's/CC=cc/CC=gcc/' Makefile > Makefile.gcc;\
	mv Makefile.gcc Makefile;\
	make;make install"

#http://www.bzip.org/1.0.5/bzip2-1.0.5.tar.gz
#f_compilelib "bzip2" "make ; make install PREFIX=$GSCRIPT_LIBDIR/\$GSCRIPT_LIB_bzip2"
if [ "$(uname -s)" == "AIX" ]; then 
	EXTRABZIPCMD="sed -e 's/-Wl,-soname -Wl,libbz2.so.1.0//' Makefile-libbz2_so >a;mv -f a Makefile-libbz2_so;" ;
else
	EXTRABZIPCMD="" ;
fi;
f_compilelib "bzip2" " \
	$EXTRABZIPCMD
	make -f Makefile-libbz2_so; \
	make install PREFIX=$GSCRIPT_LIBDIR; \
	cp -p libbz2.so* $GSCRIPT_LIBDIR/lib/; \
	ln -s libbz2.so.1.0 $GSCRIPT_LIBDIR/lib/libbz2.so \
	"

#http://voxel.dl.sourceforge.net/project/mhash/mhash/0.9.9.9/mhash-0.9.9.9.tar.gz
f_compilelib "mhash" ""
#OK INUTILE --disable-static --enable-shared --with-pic

#http://mirrors.usc.edu/pub/gnu/libiconv/libiconv-1.13.tar.gz
f_compilelib "libiconv" ""
#OK INUTILE --disable-static --enable-shared --with-pic

#ftp://alpha.gnu.org/pub/gnu/libidn/libidn-1.9.tar.gz
#f_compilelib "libidn" "--with-libiconv-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libiconv"
f_compilelib "libidn" "--with-libiconv-prefix=$GSCRIPT_LIBDIR "

#http://voxel.dl.sourceforge.net/project/mcrypt/Libmcrypt/2.5.8/libmcrypt-2.5.8.tar.gz
if [ "$(uname -s)" == "AIX" ]; then

cat <<EOCAT> $GSCRIPT_LIBSRC/mcrtmp
if [ -f configure.sav ];then cp configure.sav configure; else cp configure.sav configure; fi
ed -s configure <<EOD
/LINENO: running
+1
i
ac_sub_configure_argops=\\\$(echo \\\$ac_sub_configure_args|sed -e "s/'[a-zA-Z]*=[^']*'//g")
.
+1,+10 s/ac_sub_configure_args/ac_sub_configure_argops/g
w
q
EOD
./configure --prefix=$GSCRIPT_LIBDIR \
  --exec-prefix=$GSCRIPT_LIBDIR \
  --enable-shared 
sed -e 's/#define malloc rpl_malloc//' \
    -e 's/#define realloc rpl_realloc//' \
    config.h > a ; mv a config.h ;
make;make install PREFIX=$GSCRIPT_LIBDIR;
EOCAT
  f_compilelib "libmcrypt" ". ../mcrtmp"
  rm  $GSCRIPT_LIBSRC/mcrtmp
else
  f_compilelib "libmcrypt" ""
fi;

# libs indeps

#http://curl.haxx.se/download/curl-7.19.6.zip
#f_compilelib "curl" "--with-zlib=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_zlib"
f_compilelib "curl" "--with-zlib=$GSCRIPT_LIBDIR --with-ssl=$GSCRIPT_SSLDIR"
#http://jaist.dl.sourceforge.jp/php-i18n/18570/libmbfl-1.0.1.tar.bz2
f_compilelib "libmbfl" ""

# libs graphiques 

#http://voxel.dl.sourceforge.net/project/freetype/freetype2/2.3.9/freetype-2.3.9.tar.gz
f_compilelib "freetype" ""
#OK INUTILE f_compilelib "freetype" "--enable-static --disable-shared --with-pic"
#http://voxel.dl.sourceforge.net/project/libpng/00-libpng-stable/1.2.40/libpng-1.2.40.tar.gz
f_compilelib "libpng" ""
#OK MAIS INUTILE f_compilelib "libpng" "--disable-static --enable-shared --with-pic"
#http://download.icu-project.org/files/icu4c/4.2.1/icu4c-4_2_1-src.tgz
f_compilelib "icu" "
	cd source; \
	\$GSCRIPT_LIBCMDCONF; \
	make;make install"
#http://code.google.com/p/google-desktop-for-linux-mirror/downloads/detail?name=jpeg-6b.tar.gz&can=2&q=
f_compilelib "jpeg" ""
#OK MAIS INUTILE f_compilelib "jpeg" "--disable-static --enable-shared --with-pic"

#libs xml

#ftp://fr.rpmfind.net/pub/libxml/LATEST_LIBXML2
#--with-zlib=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_zlib 
#--with-iconv=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libiconv 

f_compilelib "libxml2" "\$GSCRIPT_LIBCMDCONF \
	--with-zlib=$GSCRIPT_LIBDIR \
	--with-iconv=$GSCRIPT_LIBDIR ;\
	sh ../../patch_makewhileread.sh; \
	make;make install"
#OK MAIS PEUT ETRE INUTILE --disable-static --enable-shared --with-pic;\
#http://sourceforge.net/projects/expat/files/expat/2.0.1/expat-2.0.1.tar.gz/download
f_compilelib "expat" ""
#ftp://xmlsoft.org/libxslt/libxslt-1.1.26.tar.gz
#--with-libxml-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libxml2; 
f_compilelib "libxslt" "\$GSCRIPT_LIBCMDCONF \
	--with-libxml-prefix=$GSCRIPT_LIBDIR ; \
	make;make install;make install-am"
#http://sourceforge.net/projects/xmlrpc-epi
f_compilelib "xmlrpc" "\$GSCRIPT_LIBCMDCONF;\
	sed -e 's/-lexpat/-lexpat -liconv/' Makefile>a;mv a Makefile;\
	sed -e 's/-lexpat/-lexpat -liconv/' src/Makefile>a;mv a src/Makefile;\
	sed -e 's/-lexpat/-lexpat -liconv/' sample/Makefile>a;mv a sample/Makefile;\
	make;make install"
#cd $GSCRIPT_LIBDIR/$GSCRIPT_LIB_xmlrpc/lib
cd $GSCRIPT_LIBDIR/lib
ln -s libxmlrpc-epi.a libxmlrpc.a
ln -s libxmlrpc-epi.so.0.0.3 libxmlrpc.so
cd $GSCRIPT_LIBSRC

#http://ftp.gnu.org/gnu/gettext/gettext-0.17.tar.gz
#f_compilelib "gettext" "--with-libexpat-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libexpat \
#	--with-libxml2-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libxml2 \
#	--with-libiconv-prefix=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_libiconv"
f_compilelib "gettext" "--with-libexpat-prefix=$GSCRIPT_LIBDIR \
	--with-libxml2-prefix=$GSCRIPT_LIBDIR \
	--with-libiconv-prefix=$GSCRIPT_LIBDIR"

#ftp://ftp.ossp.org/pkg/lib/pth/pth-2.0.7.tar.gz
f_compilelib "pth" "--with-fdsetsize=8192"

#http://apr.apache.org/download.cgi
#f_compilelib "apr" "--with-libtool=/appli/apache/system/exe/bin/libtool"
f_compilelib "apr" ""
#f_compilelib "apr-util" "--with-apr=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_apr"
#f_compilelib "apr-iconv" "--with-apr=$GSCRIPT_LIBDIR/$GSCRIPT_LIB_apr"
f_compilelib "apr-util" "--with-apr=$GSCRIPT_LIBDIR"

mv $GSCRIPT_LIBDIR/include/iconv.h $GSCRIPT_LIBDIR/include/iconv.h.libiconv
f_compilelib "apr-iconv" "--with-apr=$GSCRIPT_LIBDIR"
mv $GSCRIPT_LIBDIR/include/iconv.h.libiconv $GSCRIPT_LIBDIR/include/iconv.h


echo "--verif $GSCRIPT_LIBDIR/lib -- "
cd $GSCRIPT_LIBDIR/lib

GSCRIPT_LIBSRC_NOM_VS=`ls -d */ | sed -e 's:/::' -e 's/-[0-9\.\-]*$//' -e 's/^lib//' 2>/dev/null`;
for GSCRIPT_LIBSRC_NOM_V in apr-1 apriconv-1 aprutil-1 bz2 bz2 curl expat gettextlib jpeg apriconv-1 idn mbfl mcrypt png xml2 xslt mhash pth xmlrpc-epi xmlrpc z;do
#c=$(ls -l lib${GSCRIPT_LIBSRC_NOM_V}.so* lib${GSCRIPT_LIBSRC_NOM_V}.a|wc -l)
GSCRIPT_LIBSRC_NOM_ZZ=`ls -d zip/$GSCRIPT_LIBSRC_NOM_V*|wc -l |sed -e 's/ //g' 2>/dev/null`;
if [ "$GSCRIPT_LIBSRC_NOM_ZZ" != "0" ];then
echo $GSCRIPT_LIBSRC_NOM_ZZ
exit
 if [ -f "lib${GSCRIPT_LIBSRC_NOM_V}.so" ];then
  echo $GSCRIPT_LIBSRC_NOM_V SO ok
 else
  if [ -f "lib${GSCRIPT_LIBSRC_NOM_V}.a" ];then
   echo $GSCRIPT_LIBSRC_NOM_V A ok
  else
   echo $GSCRIPT_LIBSRC_NOM_V err
  fi
 fi
fi
done
