#!/bin/bash

. ./tools_common.inc.sh

#config du fichier
#GSCRIPT_SHARE_MYCNF="my-medium.cnf"
#GSCRIPT_DEFAULTCHARACTERSET="utf8"
#GSCRIPT_II_CREDIR="bin conf logs tmp data datalog backup"
#port web standard
GSCRIPT_PORTWEBS=80
#user web standard
GSCRIPT_USERWEBS=webadm

f_mustrunas webadm

function gs_parsrepfile
{
	GS_PARSREPFILEF=$1
	sed \
	-e "s:\#GSCRIPT_MOTEUR:$GSCRIPT_MOTEUR:g" \
	-e "s:\#GSCRIPT_DIR:$GSCRIPT_DIR:g" \
	-e "s:\#GSCRIPT_NOM:$GSCRIPT_NOM:g" \
	-e "s:\#GSCRIPT_HOME:$GSCRIPT_HOME:g" \
	-e "s:\#GSCRIPT_APPLI:$GSCRIPT_APPLI:g" \
	-e "s:\#GSCRIPT_VERSION:$GSCRIPT_VERSION:g" \
	-e "s:\#GSCRIPT_PASS_MGR:$GSCRIPT_PASS_MGR:g" \
	-e "s:\#GSCRIPT_CMD:$GSCRIPT_CMD:g" \
	-e "s:\#GSCRIPT_PORTWEB:$GSCRIPT_PORTWEB:g" \
	-e "s:\#GSCRIPT_USERWEB:$GSCRIPT_USERWEB:g" \
	-e "s:\#instance:$GSCRIPT_NOM:g" \
	-e "s:$GSCRIPT_USERWEBS:$GSCRIPT_USERWEB:g" \
	$GS_PARSREPFILEF > ${GS_PARSREPFILEF}.tmp
	mv ${GS_PARSREPFILEF}.tmp $GS_PARSREPFILEF
}


#--- options et params a choisir ---

while getopts "n:p:u:h" opt; do
        if [ "$OPTARG" = "" ]; then OPTARG=1; fi
        if [ "$opt" != '?' ] && [ "$opt" != ':' ]; then
                export OPTARG_${opt}=$OPTARG
        fi
done

echo "usage $0 -n nom [-p port(80)] [-u user(webadm)]"
if [ ! -z "$OPTARG_h" ];then
        cat <<EOT
usage $0 -n nom -t port -m pass
	-n nom (projet-perimetre)
	-p port (80 par defaut)
	-u user (webadm par defaut)
	exemple:$0 -n prj-tst -p 8081
EOT
exit
fi;

echo "creation d'une instance apache "
echo "La nouvelle instance va être créée dans un répertoire de la forme 'projet-perimetre' (ex: 'omega-frontal')"

f_read "nom projet-perimetre : " \
        "$OPTARG_n" \
        " tr [:upper:] [:lower:] " 
        GSCRIPT_NOM=`echo $F_READ_RETURN |sed 's/[^a-zA-Z0-9_\.\-]//g'` ;
		
export GSCRIPT_DIR="$GSCRIPT_HOME/$GSCRIPT_NOM"
if [ -d "$GSCRIPT_DIR" ]; then
	f_read "le répertoire $GSCRIPT_NOM existe déjà , tout supprimer ? [y/N] : " "" "tr [:upper:] [:lower:]"
	if [ "$F_READ_RETURN" = "y" ]; then rm -rf "$GSCRIPT_DIR/"; fi
	if [ -d "$GSCRIPT_DIR" ]; then echo "le répertoire $GSCRIPT_NOM existe déjà ";exit;fi
fi


echo "choix d'un port libre pour un acces apache."
f_read "port apache http ($GSCRIPT_PORTWEBS): " "$OPTARG_p" \
	" sed -e s/[^0-9]//g -e s/^$/$GSCRIPT_PORTWEBS/ " ;
GSCRIPT_PORTWEB=$F_READ_RETURN
if [ "$GSCRIPT_PORTWEB" == "" ]; then GSCRIPT_PORTWEB=$GSCRIPT_PORTWEBS; fi; 
#teste si le port serait pas deja actif par hasard
f_is_port_used $GSCRIPT_PORTWEB
if [ $? == 1 ]; then echo "Erreur, le port $GSCRIPT_PORTWEB est déjà utilisé";exit;fi;

#echo "choix d'un nom d'utilisateur apache."
#f_read "user apache ($GSCRIPT_USERWEBS): " "$OPTARG_u" \
#	" sed -e s/^$/$GSCRIPT_USERWEBS/ " ;
#GSCRIPT_USERWEB=$F_READ_RETURN
GSCRIPT_USERWEB="$OPTARG_u"
if [ "$GSCRIPT_USERWEB" == "" ]; then GSCRIPT_USERWEB=$GSCRIPT_USERWEBS; fi; 

#install command line
GSCRIPT_CMD="sh $GSCRIPT_MOTEUR/tools/install.sh -n $GSCRIPT_NOM -p $GSCRIPT_PORTWEB  -u $GSCRIPT_USERWEB ";

#--- creation ---


if [ ! -d "$GSCRIPT_DIR" ]; then
	for ldir in $GSCRIPT_II_CREDIR; do
		mkdir -p $GSCRIPT_DIR/$ldir
	done

	# copy templated bin conf  
	for lfile in `find $GSCRIPT_MOTEUR/tools/instance/`; do
		sfile=`basename $lfile|sed \
			 -e "s/GSCRIPT_NOM/$GSCRIPT_NOM/"  \
			 -e "s/GSCRIPT_APPLI/$GSCRIPT_APPLI/" `
		dir=$(dirname $lfile|sed -e "s:$GSCRIPT_MOTEUR/tools/instance::" -e 's:^/::' -e 's:^$:.:')
		if [ -d $lfile ]; then 
			mkdir -p $GSCRIPT_DIR/$dir/$sfile; 
		else
			cp -p $lfile $GSCRIPT_DIR/$dir/$sfile
			gs_parsrepfile $GSCRIPT_DIR/$dir/$sfile
		fi;
	done
fi

#create stop start scripts
chmod a+x \
	$GSCRIPT_DIR/*.sh \
	$GSCRIPT_DIR/bin/*
#protect passwords contents
chmod og-rw \
	$GSCRIPT_DIR/conf/install.conf 
	

#finalize install.conf
sed -e "s/: *#.*$/:0/g" \
	  $GSCRIPT_DIR/conf/install.conf \
	> $GSCRIPT_DIR/conf/install.conf.tmp
	mv $GSCRIPT_DIR/conf/install.conf.tmp \
	   $GSCRIPT_DIR/conf/install.conf


#cree ....

echo "commande de creation automatique "
echo "$GSCRIPT_CMD"
date >> "$GSCRIPT_DIR/logs/install.log"
echo "$GSCRIPT_CMD" >> "$GSCRIPT_DIR/logs/install.log"
echo ""
echo "commande de lancement : "
echo "$GSCRIPT_DIR/start_${GSCRIPT_APPLI}_${GSCRIPT_NOM}.sh"
echo "$GSCRIPT_DIR/stop_${GSCRIPT_APPLI}_${GSCRIPT_NOM}.sh"
echo ""
echo "sh install_startup_${GSCRIPT_APPLI}.sh ${GSCRIPT_NOM}"
echo "sh uninstall_startup_${GSCRIPT_APPLI}.sh ${GSCRIPT_NOM}"
echo ""
