#!/bin/sh
#===============================================================================#
# install_logrotate.sh
#
# installation de la rotation des logs
#
# usage : ./install_logrotate.sh [fichier de demarrage] [uninstall]
#
# error code :   0 :ok
#              1,2,3,4, : erreur 
#
#===============================================================================#

if [ $# -lt 1 ] ; then echo "Usage : ${0} instance_initd_file [uninstall] " && exit 1; fi
if [ "$(id -u)" != "0" ] ; then echo "Must run as root" && exit 5; fi

APPLI_LOGROTATE_NAMEBIN=${1}

APPLI_LOGROTATE_NAME=$(basename $APPLI_LOGROTATE_NAMEBIN)
APPLI_LOGROTATE_NAMEDIR="/etc/logrotate.d/${APPLI_LOGROTATE_NAME}"

if [ "${2}" == "uninstall" ]; then
	rm -f ${APPLI_LOGROTATE_NAMEDIR}
	echo "OK logrotate script $APPLI_LOGROTATE_NAMEDIR uninstalled"
	exit 0
fi

# Verify that the instance name and files exists
if [ -f "${APPLI_LOGROTATE_NAMEDIR}" ]; then echo "file ${APPLI_LOGROTATE_NAMEDIR} already exists" && exit 3; fi
if [ -L "${APPLI_LOGROTATE_NAMEDIR}" ]; then echo "link ${APPLI_LOGROTATE_NAMEDIR} already exists" && exit 4; fi
if [ ! -f "${APPLI_LOGROTATE_NAMEBIN}" ]; then echo "file ${APPLI_LOGROTATE_NAMEBIN} does not exists" && exit 5; fi


ln -s ${APPLI_LOGROTATE_NAMEBIN} ${APPLI_LOGROTATE_NAMEDIR}

echo "OK logrotate script $APPLI_LOGROTATE_NAMEDIR installed"
exit 0
