#!/bin/sh
#===============================================================================#
# install_startup.sh
#
# installation du demarrage automatique
#
# usage : ./install_startup.sh [fichier de demarrage]
#
# error code :   0 :ok
#              1,2,3,4, : erreur 
#
#===============================================================================#

if [ $# -lt 1 ] ; then echo "Usage : ${0} instance_initd_file [uninstall] " && exit 1; fi
if [ "$(id -u)" != "0" ] ; then echo "Must run as root" && exit 5; fi

APPLI_INITD_NAMEBIN=${1}
APPLI_INITD_NUMK="K02"
APPLI_INITD_NUMS="S98"

APPLI_INITD_NAME=$(basename $APPLI_INITD_NAMEBIN)
APPLI_INITD_NAMEDIR="/etc/init.d/${APPLI_INITD_NAME}"
APPLI_INITD_NAMEDIRK="/etc/init.d/${APPLI_INITD_NUMK}${APPLI_INITD_NAME}"
APPLI_INITD_NAMEDIRS="/etc/init.d/${APPLI_INITD_NUMS}${APPLI_INITD_NAME}"

if [ "${2}" == "uninstall" ]; then
	if [ "$(uname -s)" == "AIX" ]; then 
		rm -f ${APPLI_INITD_NAMEDIRK}
		rm -f ${APPLI_INITD_NAMEDIRS}
	else
		/sbin/chkconfig ${APPLI_INITD_NAME} off
		/sbin/chkconfig --del ${APPLI_INITD_NAME}
	fi;
	rm -f ${APPLI_INITD_NAMEDIR}
	echo "OK startup script $APPLI_INITD_NAMEDIR uninstalled"
	exit 0
fi

# Verify that the instance name and files exists
if [ -f "${APPLI_INITD_NAMEDIR}" ]; then echo "file ${APPLI_INITD_NAMEDIR} already exists" && exit 3; fi
if [ -L "${APPLI_INITD_NAMEDIR}" ]; then echo "link ${APPLI_INITD_NAMEDIR} already exists" && exit 4; fi
if [ ! -f "${APPLI_INITD_NAMEBIN}" ]; then echo "file ${APPLI_INITD_NAMEBIN} does not exists" && exit 5; fi


ln -s ${APPLI_INITD_NAMEBIN} ${APPLI_INITD_NAMEDIR}

	if [ "$(uname -s)" == "AIX" ]; then 
		ln -s ${APPLI_INITD_NAMEDIR} ${APPLI_INITD_NAMEDIRK}
		ln -s ${APPLI_INITD_NAMEDIR} ${APPLI_INITD_NAMEDIRS}
	else
		/sbin/chkconfig --add ${APPLI_INITD_NAME}
		/sbin/chkconfig ${APPLI_INITD_NAME} on
	fi;

echo "OK startup script $APPLI_INITD_NAMEDIR installed"
exit 0
