#!/bin/sh

#===============================================================================#
# patch_gaia.sh
#
# patch a appliquer avant l'execution de siteminder pour que le wizard 
# reconnaisse le fichier httpd.conf et ssl.conf
#
# usage : ./patch_gaia.sh [instance name]
#
# error code :   0 :ok
#              1,2,3,4, : erreur 
#
#===============================================================================#

# Verify that the instance name exists
if [ $# -lt 1 ] ; then
   echo "Usage : ${0} instance "
   exit 1
fi
# Define variables
if [ -f "env_apache.sh" ]; then . ./env_apache.sh ${1};else echo "please run in . directory";exit 1;fi

# Test if instance is already installed
if [ ! -d "${APACHE_INSTANCE_HOME}" ]; then
    echo "Instance $APACHE_INSTANCE does not exists"
    exit 2
fi

#create dummy ssl.conf for gaia
if [ ! -f "${APACHE_INSTANCE_HOME}/conf/ssl.conf" ]; then
	touch ${APACHE_INSTANCE_HOME}/conf/ssl.conf
	chown webadm:webgrp ${APACHE_INSTANCE_HOME}/conf/ssl.conf
fi
if [ "$(grep -c 'SSLVerifyClient'  ${APACHE_INSTANCE_HOME}/conf/ssl.conf)" == "0" ]; then
	echo "#SSLVerifyClient require" >> ${APACHE_INSTANCE_HOME}/conf/ssl.conf
fi

#create dummy lines in httpd.conf for gaia
if [ "$(grep -c 'Section 1: Global Environment'  ${APACHE_INSTANCE_HOME}/conf/httpd.conf)" == "0" ]; then
ed -s ${APACHE_INSTANCE_HOME}/conf/httpd.conf <<EOF
/^$
+1
i
#Ajout pour Wizard Gaia/Siteminder
### Section 1: Global Environment
# LoadModule foo_module
# Alias /webpath
# AddHandler
#AddHandler cgi-script .cgi
#ScriptAlias /cgi-bin/ "/var/www/cgi-bin/"

.
w
q
EOF
fi

#double check just in case
#unix2dos ${APACHE_INSTANCE_HOME}/conf/httpd.conf
chown webadm:webgrp ${APACHE_INSTANCE_HOME}/conf/httpd.conf
#unix2dos ${APACHE_INSTANCE_HOME}/conf/ssl.conf
chown webadm:webgrp ${APACHE_INSTANCE_HOME}/conf/ssl.conf

echo "patch Gaia"
if [ "$(grep -c 'SSLVerifyClient'  ${APACHE_INSTANCE_HOME}/conf/ssl.conf)" != "0" ]; then echo "ssl.conf : OK";else echo "ssl.conf : ERR" && exit 3;fi
if [ "$(grep -c 'Section 1: Global Environment'  ${APACHE_INSTANCE_HOME}/conf/httpd.conf)"  != "0" ]; then echo "httpd.conf : OK";else echo "httpd.conf : ERR" && exit 4; fi
 
