#!/bin/sh
#===============================================================================#
# update_sudoweb.sh
#
# ex: update_sudoweb.sh "CMD_APACHE2211G" "${GSCRIPT_MOTEUR}/bin/apachectl,${GSCRIPT_MOTEUR}/bin/httpd"
# installation mise a jour du sudo 
#
# error code :   0 :ok
#              1,2,3,4, : erreur 
#
#===============================================================================#

if [ $# -lt 2 ] ; then echo "Usage : ./${0} [instance_tag] [instance_commandes] " && exit 1; fi

if [ "$(id -u)" != "0" ] ; then echo "Must run as root" && exit 5; fi

SUDOCMDALIAS=${1}
SUDOCMDCMDS=${2}

SUDOCMDALIAS=$(echo "${SUDOCMDALIAS}"|tr [:lower:] [:upper:]|sed -e 's/[\. \-]//g')


SUDOERSF="/etc/sudoers"
SUDOERST="/tmp/sudoers.tmp"
cp -f $SUDOERSF $SUDOERST
chmod a+w $SUDOERST

grep_count=$(grep -c "User_Alias OP_WEB = webadm" $SUDOERST)
if [ "$grep_count" == "0" ]; then 
	echo "User_Alias OP_WEB = webadm, w3user" >> $SUDOERST
fi

grep_count=$(grep -c "Host_Alias SERV_LOCAL" $SUDOERST)
if [ "$grep_count" == "0" ]; then 
	HOSTSF="/tmp/hosts.tmp"
	hostname >> $HOSTSF
	hostname | sed -e 's/\..*$//' >> $HOSTSF
if [ "$(uname -s)" != "AIX" ]; then
	hostname -f >> $HOSTSF
	hostname -d >> $HOSTSF
	hostname -s >> $HOSTSF
	hostname -i >> $HOSTSF
fi
	ifconfig -a|grep "inet adr:"|sed -e "s/^ *inet adr://" -e "s/ .*$//" >> $HOSTSF
	HOSTSFJ=$(sort -u $HOSTSF|tr "\n" ","|sed -e 's/,,/,/' -e 's/^,//' -e 's/,$//')
	rm $HOSTSF
	echo "Host_Alias SERV_LOCAL = $HOSTSFJ" >> $SUDOERST
fi

grep_count=$(grep -c "Cmnd_Alias $SUDOCMDALIAS" $SUDOERST)
if [ "$grep_count" == "0" ]; then 
	echo "Cmnd_Alias $SUDOCMDALIAS" >> $SUDOERST
fi
sed -e "s:^.*Cmnd_Alias $SUDOCMDALIAS.*$:Cmnd_Alias $SUDOCMDALIAS = $SUDOCMDCMDS:" $SUDOERST>tmpupdtsudoweb ; mv tmpupdtsudoweb $SUDOERST

grep_count=$(grep -c "OP_WEB SERV_LOCAL = NOPASSWD:$SUDOCMDALIAS" $SUDOERST)
if [ "$grep_count" == "0" ]; then 
	echo "OP_WEB SERV_LOCAL = NOPASSWD:$SUDOCMDALIAS" >> $SUDOERST
fi

SUDOERSV=$(/usr/sbin/visudo -scf $SUDOERST|grep -c OK)

if [ "$SUDOERSV" == "1" ]; then
	cp -pf $SUDOERST $SUDOERSF
	chmod 440 $SUDOERSF
	echo "ok, $SUDOERSF updated"
else
	echo "Error sudoers patch invalid"
	exit 6
fi
rm -f $SUDOERST


